<template>
	<div>
		<!--增、查交易记录的按钮-->
		<el-button type="primary" round @click="openAddDialog" size="small">添加</el-button>
		<!--表格-->
		<el-row>
			<el-col :span="24">
				<el-table :data="state.getList">
					<!--					列表结开始-->
					<el-table-column prop="id" label="编号" align="center" />
					<el-table-column prop="name" label="轮播名称" align="center" />
					<el-table-column prop="largePic" label="图片" align="center" >
						<template #default="{ row }">
							<!-- 点击图片后显示弹框预览 -->
							<el-image
								:src="row.path"
								fit="cover"
								style="width: 200px;height: 100px"
								:preview-src-list="[row.path]"
								:preview-teleported="true"
							/>
						</template>
					</el-table-column>
					<!--列表结束-->
					<el-table-column label="操作" align="center" >
						<template #default="scope">
							<el-button @click="edit(scope.row)" size="small">编辑</el-button>
							<el-button @click="del(scope.row.id)" type="danger" size="small">删除</el-button>
						</template>
					</el-table-column>
					<template v-slot:empty>
						<el-empty description="数据去外太空了~" />
					</template>
				</el-table>
				<!-- 分页控件 -->
				<el-pagination
					v-if="state.query.total > 0"
					:current-page="state.query.page"
					:page-size="state.query.limit"
					:total="state.query.total"
					background layout="prev, pager, next"
					@current-change="handlePageChange"
				/>
			</el-col>
		</el-row>

		<!-- 新增/编辑对话框 -->
		<el-dialog v-model="state.dialogVisible" title="新增" width="50%">
			<el-form
				:model="state.formData"
				ref="formRef"
				label-width="100px"
			>
				<!--				表单开始===============================================================================================================================-->

				<el-form-item label="轮播名称" prop="name" :rules="[{ required: true, message: '请输入轮播名称', trigger: 'blur' }]">
					<el-input v-model="state.formData.name"/>
				</el-form-item>
				<el-form-item label="图片" prop="path" :rules="[{ required: true, message: '请插入图片', trigger: 'blur' }]">
						<image-upload @update:imageUrl="handleImageUrl"  :image-url="state.formData.path"></image-upload>
				</el-form-item>

				<!--表单结束===============================================================================================================================-->
			</el-form>
			<div slot="footer" class="dialog-footer">
				<el-button @click="state.dialogVisible = false">取消</el-button>
				<el-button type="primary" @click="saveTransaction(formRef)">保存</el-button>
			</div>
		</el-dialog>
	</div>
</template>
<script setup lang="ts">
// 交易记录数据
import type { FormInstance } from 'element-plus'

const formRef = ref<FormInstance>()
const state = reactive({
	route:"sys/slides",
	dialogVisible:false,
	getList: [],//获取数据
	query:{
		total: 0, // 总记录数
		page: 1, // 当前页码
		limit: 10, // 每页显示的记录数
	},
	formData:{}
})

// 接收子组件传递的路径
function handleImageUrl(path: string) {
	state.formData.path = path

}

// 获取交易记录
const init = () => {
	adminRequest.get(`${state.route}/page`, {
		params: state.query
	}).then((res:any) => {
		state.getList = res.data.list
		state.query.total = res.data.total
	})
}
// 新增交易记录
const openAddDialog = () => {
	// formData = {
	// 	name:"",
	// 	path:"",
	// }
	state.dialogVisible = true
}
// 编辑交易记录
const edit = (row: any) => {
	state.formData = row
	state.dialogVisible = true
}

// 保存记录
const saveTransaction = (formEl: FormInstance | undefined) => {
	if (!formEl) return
	formEl.validate((valid) => {
		if (valid) {
			if (state.formData.id) {
				// 更新交易记录
				adminRequest.put(`${state.route}`, state.formData).then(()=>{
					init()
					state.dialogVisible = false
					ElMessage.success("提交成功~")
				})
			} else {
				// 新增交易记录
				adminRequest.post(`${state.route}`, state.formData).then(() =>{
					init()
					state.dialogVisible = false
					ElMessage.success("提交成功~")
				})
			}

		}
	})
}



// 删除交易记录
const del = async (id: number) => {
	try {
		await adminRequest.delete(`${state.route}/${id}`)
		init()
		ElMessage.success("删除成功~")
	} catch (error) {
		ElMessage.error("删除失败~")
	}
}

// 页码改变时的处理函数
const handlePageChange = (page: number) => {
	state.query.page = page
	init()
}
// 页面加载时获取交易记录
onMounted(() => {
	init()
})
</script>
<style scoped>
.dialog-footer {
	text-align: right;
}
:deep(.el-upload) {
	border: 1px dashed var(--el-border-color);
	border-radius: 6px;
	cursor: pointer;
	position: relative;
	overflow: hidden;
	transition: var(--el-transition-duration-fast);
}

:deep(.el-upload:hover) {
	border-color: var(--el-color-primary);
}

.el-icon.avatar-uploader-icon {
	font-size: 28px;
	color: #8c939d;
	width: 178px;
	height: 178px;
	text-align: center;
}
.avatar{
	width: 178px;
	height: 178px;
	object-fit: cover;
}

</style>
<route lang="json">
{
"meta": {
"layout": "admin"
}
}
</route>
